; ***********************************************************************
; ***********************************************************************
; *                                                                     *
; *                     Text writing program                            *
; *                                                                     *
; ***********************************************************************
; ***********************************************************************

.386p 
.model flat
.data
TxtCol          db      15              ; colour
NoBgr           db      0
.code 
include Gb.Inc

; ***********************************************************************
; *                                                                     *
; *                         Clear line at EBX                           *
; *                                                                     *
; ***********************************************************************

TxtEOL Proc
        push    eax ebx ecx
        xor     eax,eax
        mov     ecx,320*8/4
        add     ebx,[VideoRAM]
TxtEOL1:mov     [ebx],eax
        add     ebx,4
        dec     ecx
        jnz     TxtEOL1
        pop     ecx ebx eax
        ret
EndP TxtEOL

; ***********************************************************************
; *                                                                     *
; *                          Set text colour                            *
; *                                                                     *
; ***********************************************************************

TxtColour Proc
        mov     [TxtCol],al
        ret
EndP TxtColour

; ***********************************************************************
; *                                                                     *
; *          Display ASCIIZ String at EDX at offset EBX                 *
; *                                                                     *
; ***********************************************************************

TxtString Proc
        push    eax
TSLoop: mov     al,[edx]
        cmp     al,0
        jz      TSExit
        call    TxtCharacter
        inc     edx
        jmp     TSLoop
TSExit: pop     eax
        ret
EndP TxtString

; ***********************************************************************
; *                                                                     *
; *             Display text character AL at offset EBX                 *
; *                                                                     *
; ***********************************************************************

TxtCharacter Proc
        push    eax ebx ecx edx
        xor     ecx,ecx
        cmp     al,'a'                  ; capitalise
        jb      Find1
        cmp     al,'z'
        ja      Find1
        sub     al,32
Find1:  mov     ah,[byte ptr TextChars+ecx] ; look for the character
        cmp     ah,al                   ; the char number will be in cl
        je      Found1
        inc     ecx
        cmp     ah,0
        jnz     Find1
        xor     ecx,ecx                 ; if end display space
Found1: add     ebx,[VideoRAM]          ; convert address to real address
        movzx   eax,cl                  ; extend cl to 32 bits
        shl     eax,3                   ; convert to a data address
        add     eax,offset TextTable
        mov     cl,7
        add     ebx,320
CharLoop:
        cmp     [NoBgr],0
        jnz     NoClr
        xor     edx,edx
        mov     [ebx],edx
        mov     [ebx+4],edx
        mov     [ebx+320],edx
        mov     [ebx+324],edx
NoClr:
        mov     ch,[eax]
        call    CharLine                ; do the line.
        add     ebx,320                 ; next line down
        inc     eax
        dec     cl
        jnz     CharLoop
        pop     edx ecx ebx eax
        add     ebx,8
        ret
CharLine:
        push    eax ebx ecx
        mov     al,[TxtCol]
CLLoop: test    ch,128
        jz      CLSkip
        mov     [ebx],al
CLSkip: inc     ebx
        add     ch,ch
        jnz     CLLoop
        pop     ecx ebx eax
        ret
EndP TxtCharacter

TextChars:      db      ' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ().",+->$!',0

TextTable:      db      00000000b       ; character 0 (space)
                db      00000000b
                db      00000000b
                db      00000000b
                db      00000000b
                db      00000000b
                db      00000000b
                db      00000000b

                db      01111100b       ; character 1 (0)
                db      11000110b
                db      11001110b
                db      11010110b
                db      11100110b
                db      11000110b
                db      01111100b
                db      00000000b

                db      00011000b       ; character 2 (1)
                db      00111000b
                db      00011000b
                db      00011000b
                db      00011000b
                db      00011000b
                db      01111110b
                db      00000000b

                db      01111100b       ; character 3 (2)
                db      11000110b
                db      00000110b
                db      01111100b
                db      11000000b
                db      11000000b
                db      11111110b
                db      00000000b

                db      01111100b       ; character 4 (3)
                db      11000110b
                db      00000110b
                db      01111100b
                db      00000110b
                db      11000110b
                db      01111100b
                db      00000000b

                db      00001100b       ; character 5 (4)
                db      00011100b
                db      00111100b
                db      01101100b
                db      11111110b
                db      00001100b
                db      00001100b
                db      00000000b

                db      11111110b       ; character 6 (5)
                db      11000010b
                db      11000000b
                db      11111100b
                db      00000110b
                db      11000110b
                db      01111100b
                db      00000000b

                db      01111100b       ; character 7 (6)
                db      11000110b
                db      11000000b
                db      11111100b
                db      11000110b
                db      11000110b
                db      01111100b
                db      00000000b

                db      11111110b       ; character 8 (7)
                db      11000110b
                db      00001100b
                db      00011000b
                db      00110000b
                db      01100000b
                db      11000000b
                db      00000000b

                db      01111100b       ; character 9 (8)
                db      11000110b
                db      11000110b
                db      01111100b
                db      11000110b
                db      11000110b
                db      01111100b
                db      00000000b

                db      01111100b       ; character 10 (9)
                db      11000110b
                db      11000110b
                db      01111110b
                db      00000110b
                db      11000110b
                db      01111100b
                db      00000000b

                db      00111000b       ; character 11 (A)
                db      01101100b
                db      11000110b
                db      11111110b
                db      11000110b
                db      11000110b
                db      11000110b
                db      00000000b

                db      11111100b       ; character 12 (B)
                db      11000110b
                db      11000110b
                db      11111100b
                db      11000110b
                db      11000110b
                db      11111100b
                db      00000000b

                db      01111100b       ; character 13 (C)
                db      11000110b
                db      11000000b
                db      11000000b
                db      11000000b
                db      11000110b
                db      01111100b
                db      00000000b

                db      11111000b       ; character 14 (D)
                db      11001100b
                db      11000110b
                db      11000110b
                db      11000110b
                db      11001100b
                db      11111000b
                db      00000000b

                db      11111110b       ; character 15 (E)
                db      11000000b
                db      11000000b
                db      11111110b
                db      11000000b
                db      11000000b
                db      11111110b
                db      00000000b

                db      11111110b       ; character 16 (F)
                db      11000000b
                db      11000000b
                db      11111110b
                db      11000000b
                db      11000000b
                db      11000000b
                db      00000000b

                db      01111100b       ; character 17 (G)
                db      11000110b
                db      11000000b
                db      11011110b
                db      11000110b
                db      11000110b
                db      01111100b
                db      00000000b

                db      11000110b       ; character 18 (H)
                db      11000110b
                db      11000110b
                db      11111110b
                db      11000110b
                db      11000110b
                db      11000110b
                db      00000000b

                db      01111110b       ; character 19 (I)
                db      00011000b
                db      00011000b
                db      00011000b
                db      00011000b
                db      00011000b
                db      01111110b
                db      00000000b

                db      11111110b       ; character 20 (J)
                db      00011000b
                db      00011000b
                db      00011000b
                db      00011000b
                db      11011000b
                db      01110000b
                db      00000000b

                db      11000110b       ; character 21 (K)
                db      11001100b
                db      11011000b
                db      11110000b
                db      11011000b
                db      11001100b
                db      11000110b
                db      00000000b

                db      11000000b       ; character 22 (L)
                db      11000000b
                db      11000000b
                db      11000000b
                db      11000000b
                db      11000000b
                db      11111110b
                db      00000000b

                db      11000110b       ; character 23 (M)
                db      11000110b
                db      11101110b
                db      11010110b
                db      11000110b
                db      11000110b
                db      11000110b
                db      00000000b

                db      11000110b       ; character 24 (N)
                db      11000110b
                db      11100110b
                db      11010110b
                db      11001110b
                db      11000110b
                db      11000110b
                db      00000000b

                db      01111100b       ; character 25 (O)
                db      11000110b
                db      11000110b
                db      11000110b
                db      11000110b
                db      11000110b
                db      01111100b
                db      00000000b

                db      11111100b       ; character 26 (P)
                db      11000110b
                db      11000110b
                db      11111100b
                db      11000000b
                db      11000000b
                db      11000000b
                db      00000000b

                db      01111100b       ; character 27 (Q)
                db      11000110b
                db      11000110b
                db      11000110b
                db      11001110b
                db      11000100b
                db      01111010b
                db      00000000b

                db      11111100b       ; character 28 (R)
                db      11000110b
                db      11000110b
                db      11111100b
                db      11011000b
                db      11001100b
                db      11000110b
                db      00000000b

                db      01111100b       ; character 29 (S)
                db      11000110b
                db      11000000b
                db      01111100b
                db      00000110b
                db      11000110b
                db      01111100b
                db      00000000b

                db      01111110b       ; character 30 (T)
                db      00011000b
                db      00011000b
                db      00011000b
                db      00011000b
                db      00011000b
                db      00011000b
                db      00000000b

                db      11000110b       ; character 31 (U)
                db      11000110b
                db      11000110b
                db      11000110b
                db      11000110b
                db      11000110b
                db      01111100b
                db      00000000b

                db      11000110b       ; character 32 (V)
                db      11000110b
                db      11000110b
                db      11000110b
                db      01101100b
                db      00111000b
                db      00010000b
                db      00000000b

                db      11000110b       ; character 33 (W)
                db      11000110b
                db      11000110b
                db      11010110b
                db      11101110b
                db      11000110b
                db      11000110b
                db      00000000b

                db      11000110b       ; character 34 (X)
                db      01101100b
                db      00111000b
                db      00111000b
                db      00111000b
                db      01101100b
                db      11000110b
                db      00000000b

                db      11000011b       ; character 35 (Y)
                db      01100110b
                db      00111100b
                db      00011000b
                db      00011000b
                db      00011000b
                db      00011000b
                db      00000000b

                db      11111110b       ; character 36 (Z)
                db      00000110b
                db      00001100b
                db      00011000b
                db      00110000b
                db      01100000b
                db      11111110b
                db      00000000b

                db      00011000b       ; character 37 (()
                db      00110000b
                db      01100000b
                db      01100000b
                db      01100000b
                db      00110000b
                db      00011000b
                db      00000000b

                db      00110000b       ; character 38 ())
                db      00011000b
                db      00001100b
                db      00001100b
                db      00001100b
                db      00011000b
                db      00110000b
                db      00000000b

                db      00000000b       ; character 39 (.)
                db      00000000b
                db      00000000b
                db      00000000b
                db      00111000b
                db      00111000b
                db      00000000b
                db      00000000b

                db      01101100b       ; character 40 (")
                db      01101100b
                db      00000000b
                db      00000000b
                db      00000000b
                db      00000000b
                db      00000000b
                db      00000000b

                db      00000000b       ; character 41 (,)
                db      00000000b
                db      00000000b
                db      00000000b
                db      00111000b
                db      00111000b
                db      01110000b
                db      00000000b

                db      00011000b       ; character 42 (+)
                db      00011000b
                db      00011000b
                db      01111110b
                db      00011000b
                db      00011000b
                db      00011000b
                db      00000000b

                db      00000000b       ; character 43 (-)
                db      00000000b
                db      00000000b
                db      11111110b
                db      00000000b
                db      00000000b
                db      00000000b
                db      00000000b

                db      11110000b       ; character 44 (>)
                db      11111000b
                db      01111100b
                db      00111110b
                db      01111100b
                db      11111000b
                db      11110000b
                db      00000000b

                db      00011000b       ; character 45 ($)
                db      01111100b
                db      11000000b
                db      01111110b
                db      00000011b
                db      01111110b
                db      00011000b
                db      00000000b

                db      00011000b       ; character 46 (!)
                db      00111100b
                db      00111100b
                db      00011000b
                db      00000000b
                db      00011000b
                db      00011000b
                db      00000000b

End
